AnimalDealerChangeSettingsEvent = {};
AnimalDealerChangeSettingsEvent_mt = Class(AnimalDealerChangeSettingsEvent, Event);
InitEventClass(AnimalDealerChangeSettingsEvent, "AnimalDealerChangeSettingsEvent");

AnimalDealerChangeSettingsEvent.NUM_BITS_SETTINGS_ID = 1;
AnimalDealerChangeSettingsEvent.NUM_BITS_STATE = 2;

---Create instance of Event class
-- @return table self instance of class event
function AnimalDealerChangeSettingsEvent.emptyNew()
    local self = Event.new(AnimalDealerChangeSettingsEvent_mt);
    return self;
end;

---Create new instance of event
-- @param table object object
-- @param string, string
function AnimalDealerChangeSettingsEvent.new(settingsId, settingsState)
    local self = AnimalDealerChangeSettingsEvent.emptyNew();
    self.settingsId = settingsId;
    self.settingsState = tostring(settingsState);	
    return self;
end;

---Called on client side on join
-- @param string streamId streamId
-- @param string connection connection
function AnimalDealerChangeSettingsEvent:readStream(streamId, connection)
    self.settingsId = streamReadString(streamId, AnimalDealerChangeSettingsEvent.NUM_BITS_SETTINGS_ID);
    self.settingsState = streamReadString(streamId, AnimalDealerChangeSettingsEvent.NUM_BITS_STATE);
    self:run(connection);
end;

---Called on server side on join
-- @param string streamId streamId
-- @param string connection connection
function AnimalDealerChangeSettingsEvent:writeStream(streamId, connection)
    streamWriteString(streamId, self.settingsId, AnimalDealerChangeSettingsEvent.NUM_BITS_SETTINGS_ID);
    streamWriteString(streamId, self.settingsState, AnimalDealerChangeSettingsEvent.NUM_BITS_STATE);
end;

---Run action on receiving side
-- @param string connection connection
function AnimalDealerChangeSettingsEvent:run(connection)	
	if self.settingsId == "animalDealerMission_minMax" then
		g_additionalContractTypes:getTyp("animalDealerMission"):setMaxNumInstance(g_additionalContractUtils:getTypToString(self.settingsState));
	end;	
    if g_server ~= nil then
        g_server:broadcastEvent(self, false);
    end;
end;

